Subject: bug#58689: 13.1.4; LaTeX-modify-environment fails to modify a single line environment.

From: Jean-Jacques Rétorré <[email-masked]>
Date: Fri, 21 Oct 2022 15:19:32 +0200

Emacs  : GNU Emacs 27.1 (build 1, i686-pc-linux-gnu, GTK+ Version 3.24.24, cairo version 1.16.0)
 of 2021-03-28, modified by Debian
Package: 13.1.4

current state:
==============
(setq
 AUCTeX-date "2022-08-26"
 window-system 'x
 LaTeX-version "2e"
 TeX-style-path '("~/.emacs.d/auctex" "/home/debjjr/.emacs.d/elpa/auctex-13.1.4/style" "/home/debjjr/.emacs.d/auctex/auto"
                  "/home/debjjr/.emacs.d/auctex/style" "auto" "style")
 TeX-auto-save t
 TeX-parse-self t
 TeX-master t
 TeX-command-list '(("TeX" "%(PDF)%(tex) %(file-line-error) %`%(extraopts) %S%(PDFout)%(mode)%' %(output-dir) %t" TeX-run-TeX nil
                     (plain-tex-mode texinfo-mode ams-tex-mode) :help "Run plain TeX")
                    ("LaTeX" "%`%l%(mode)%' %T" TeX-run-TeX nil (latex-mode doctex-mode) :help "Run LaTeX")
                    ("Makeinfo" "makeinfo %(extraopts) %(o-dir) %t" TeX-run-compile nil (texinfo-mode) :help
                     "Run Makeinfo with Info output")
                    ("Makeinfo HTML" "makeinfo %(extraopts) %(o-dir) --html %t" TeX-run-compile nil (texinfo-mode) :help
                     "Run Makeinfo with HTML output")
                    ("AmSTeX" "amstex %(PDFout) %`%(extraopts) %S%(mode)%' %(output-dir) %t" TeX-run-TeX nil (ams-tex-mode) :help
                     "Run AMSTeX")
                    ("ConTeXt" "%(cntxcom) --once --texutil %(extraopts) %(execopts)%t" TeX-run-TeX nil (context-mode) :help
                     "Run ConTeXt once")
                    ("ConTeXt Full" "%(cntxcom) %(extraopts) %(execopts)%t" TeX-run-TeX nil (context-mode) :help
                     "Run ConTeXt until completion")
                    ("BibTeX" "%(bibtex) %s" TeX-run-BibTeX nil
                     (plain-tex-mode latex-mode doctex-mode context-mode texinfo-mode ams-tex-mode) :help "Run BibTeX")
                    ("Biber" "biber %(output-dir) %s" TeX-run-Biber nil
                     (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode) :help "Run Biber")
                    ("Texindex" "texindex %s.??" TeX-run-command nil (texinfo-mode) :help "Run Texindex")
                    ("Texi2dvi" "%(PDF)texi2dvi %t" TeX-run-command nil (texinfo-mode) :help "Run Texi2dvi or Texi2pdf")
                    ("View" "%V" TeX-run-discard-or-function t t :help "Run Viewer")
                    ("Print" "%p" TeX-run-command t t :help "Print the file")
                    ("Queue" "%q" TeX-run-background nil t :help "View the printer queue" :visible TeX-queue-command)
                    ("File" "%(o?)dvips %d -o %f " TeX-run-dvips t (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode)
                     :help "Generate PostScript file")
                    ("Dvips" "%(o?)dvips %d -o %f " TeX-run-dvips nil (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode)
                     :help "Convert DVI file to PostScript")
                    ("Dvipdfmx" "dvipdfmx -o %(O?pdf) %d" TeX-run-dvipdfmx nil
                     (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode) :help "Convert DVI file to PDF with dvipdfmx")
                    ("Ps2pdf" "ps2pdf -dALLOWPSTRANSPARENCY  %f %(O?pdf)" TeX-run-ps2pdf nil
                     (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode) :help "Convert PostScript file to PDF")
                    ("Glossaries" "makeglossaries %(d-dir) %s" TeX-run-command nil
                     (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode) :help
                     "Run makeglossaries to create glossary file")
                    ("Index" "%(makeindex) %s" TeX-run-index nil (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode) :help
                     "Run makeindex to create index file")
                    ("upMendex" "upmendex %(O?idx)" TeX-run-index t (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode)
                     :help "Run upmendex to create index file")
                    ("Xindy" "texindy %s" TeX-run-command nil (plain-tex-mode latex-mode doctex-mode texinfo-mode ams-tex-mode) :help
                     "Run xindy to create index file")
                    ("Check" "lacheck %s" TeX-run-compile nil (latex-mode) :help "Check LaTeX file for correctness")
                    ("ChkTeX" "chktex -v6 %s" TeX-run-compile nil (latex-mode) :help "Check LaTeX file for common mistakes")
                    ("Spell" "(TeX-ispell-document \"\")" TeX-run-function nil t :help "Spell-check the document")
                    ("Clean" "TeX-clean" TeX-run-function nil t :help "Delete generated intermediate files")
                    ("Clean All" "(TeX-clean t)" TeX-run-function nil t :help "Delete generated intermediate and output files")
                    ("Other" "" TeX-run-command t t :help "Run an arbitrary command")
                    ("Latex Indent" "latexindent -w -s %a" TeX-run-command nil t :help "Run Latexindent on file.")
                    ("Pythontex" "pythontex --interpreter \"python:python3\" %t" TeX-run-command nil t :help "Run pythontex on file"))
 )

As a MWE

,----
| \documentclass{article}
| \begin{document}
| \begin{pmatrix} 1 & 2 \\ 3 & 4 \end{pmatrix}
| \end{document}
`----

C-u C-c C-e RET bmatrix produce

,----
| \documentclass{article}
| \begin{bmatrix}
| \begin{pmatrix} 1 & 2 \\ 3 & 4 \end{bmatrix}
| \end{document}
`----

I commented the 886 line from latex.el to correct this issue, but
I do not know wether it can have side effects.

       (save-excursion
         (funcall goto-end)
         (let ((old-env (match-string 1)))
           (replace-match environment t t nil 1)
;;l 886     (beginning-of-line 1)
           (funcall goto-begin)
           (replace-match environment t t nil 1)

This issue occurs when I use embedded calc to write a matrix in LaTeX
form.

--
JJ. Rétorré